﻿//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_///
//   漫画ビューワスクリプト Javascript必須版 ver.0.2 by SimK  //
//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_///

var piyocomic = new function() {
	var Num = 1;
	var bName = "";
	var defext = "jpg";
	if("MaxPage" in window){
		// 指定したページ数で実行
		if(MaxPage < 0){
			MaxPage = 0;
		}
	}else{
		MaxPage = 0;
	}
	if("baseName" in window){
		bName = baseName;
	}
	if("FileExt" in window){
		defext = FileExt;
	}

	var spmode = false;
	var piyocomicHeader;
	var piyocomicMain;
	var piyocomicFooter;
	var spNextButton;
	var spPrevButton;
	var spJumpNum;
	var spJumpButton;
	var spImages = new Array(MaxPage);
	var spImgLoaded = new Array(MaxPage);
	var spImgErrs = new Array(MaxPage);
	if(navigator.userAgent.indexOf('iPhone') > 0 || navigator.userAgent.indexOf('iPad') > 0 || navigator.userAgent.indexOf('iPod') > 0 || navigator.userAgent.indexOf('Android') > 0){
		spmode = true;
	}
	window.addEventListener("load", function(){
		// メインコンテナ
		piyocomicHeader = document.getElementById("piyocomicHeader");
		piyocomicMain = document.getElementById("piyocomicMain");
		piyocomicFooter = document.getElementById("piyocomicFooter");
		
		// ボタン類
		spNextButton = document.getElementById("spNextButton");
		spPrevButton = document.getElementById("spPrevButton");
		spJumpNum = document.getElementById("spJumpNum");
		spJumpButton = document.getElementById("spJumpButton");
		spTotalPages = document.getElementById("spTotalPages");
		spJumpButton.onclick = function(){piyocomic.jump(parseInt(document.getElementById("spJumpNum").value))};
		spJumpNum.min = 1;
		spJumpNum.max = MaxPage;
		spNextButton.onclick = function(){piyocomic.jump(Num+1)};
		spPrevButton.onclick = function(){piyocomic.jump(Num-1)};
		spTotalPages.innerHTML = "/"+MaxPage;
		spJumpNum.value = Num;
		
		for(i=0;i<MaxPage;i++){
			spImages[i] = document.createElement("img");
			spImages[i].style.maxWidth = "100%";
			spImages[i].onerror = function(){spImgErrs[spImages.indexOf(this)] = true;this.alt="クリックで再読込します";this.style.width=(spImages[0].clientWidth)+"px";};
			spImages[i].onload  = function(){this.style.height = "auto";this.style.minHeight = "0";this.style.maxWidth = "100%";this.style.width="auto";};
			spImages[i].onclick = function(){
				i = spImages.indexOf(this);
				if(spImgErrs[i]){
					spImages[i].src = "";
					spImgLoaded[i] = false;
					spImgErrs[i] = false;
				}
				if(!spImgLoaded[i]){
					spImages[i].src = bName+(i+1)+"."+defext;
					spImgLoaded[i] = true;
				}
				//this.style.minHeight = spImages[0].clientHeight+"px"; spImgErrs[spImages.indexOf(this)] = true;
				if(piyocomicHeader.style.position=="fixed"){
					piyocomicHeader.style.position = "static";
					piyocomicMain.style.paddingTop = "0px";
					document.body.scrollTop = document.body.scrollTop + (piyocomicHeader.clientHeight + 1);
				}else{
					piyocomicHeader.style.position = "fixed";
					piyocomicHeader.style.left = "0px";
					piyocomicHeader.style.right = "0px";
					piyocomicHeader.style.top = "0px";
					piyocomicMain.style.paddingTop = (piyocomicHeader.clientHeight+1)+"px";
					document.body.scrollTop = document.body.scrollTop - (piyocomicHeader.clientHeight + 1);
				}
			};
			piyocomicMain.appendChild(spImages[i]);
			if(i==0){
				spImages[0].onload = function(){
					for(i=0;i<MaxPage;i++){
						if(!spImgLoaded[i]){
							spImages[i].style.minHeight = spImages[0].clientHeight+"px";
						}
					}
					this.style.height = "auto";
					this.style.minHeight = "auto";
					
					for(i=1;i<MaxPage;i++){
						spImages[i].style.minHeight = spImages[0].clientHeight+"px";
					}
					onScrollViewer();
				};
				spImages[0].src = bName+"1."+defext;//?d="+(new Date()).getTime();
				spImgLoaded[0] = true;
			}
		}
	}, false);
	window.addEventListener("scroll", onScrollViewer, false);
	window.addEventListener("resize", onScrollViewer, false);
	function onScrollViewer(){
		for(i=0;i<MaxPage;i++){
			if(!spImgLoaded[i] && spImages[i].offsetTop+spImages[i].clientHeight > document.body.scrollTop && spImages[i].offsetTop <= document.body.scrollTop+document.body.clientHeight*2){
				spImages[i].src = bName+(i+1)+"."+defext;
				spImgLoaded[i] = true;
			}
		}
		for(i=0;i<MaxPage;i++){
			if(spImgLoaded[i]){
				//spImages[i].style.height = "auto";
			}
		}
		for(i=0;i<MaxPage;i++){
			if(document.body.scrollTop < spImages[i].offsetTop+spImages[i].clientHeight*3/4){
				if(spJumpNum.value!=i+1){
					spJumpNum.value = i+1;
					Num = i+1;
				}
				break;
			}
		}
		if(i==MaxPage){
			if(spJumpNum.value!=MaxPage){
				spJumpNum.value = MaxPage;
				Num = MaxPage;
			}
		}
	};

	this.next = function()
	{
		this.jump(Num+1);
	};

	this.prev = function()
	{
		this.jump(Num-1);
	};

	this.jump = function(page)
	{
		Num = parseInt(page);
		if(Num <= 0) Num = 1;
		if(Num > MaxPage) Num = MaxPage;
		if(piyocomicHeader.style.position=="fixed"){
			document.body.scrollTop = spImages[Num-1].offsetTop - (piyocomicHeader.clientHeight + 1);
		}else{
			document.body.scrollTop = spImages[Num-1].offsetTop;
		}
		spJumpNum.value = Num;
	};

};
